diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/type-traits.h ns-3.31/src/core/model/type-traits.h
--- ns-3.30.1/src/core/model/type-traits.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/type-traits.h	2020-06-27 17:38:30.000000000 -0700
@@ -29,7 +29,7 @@
  */
 
 namespace ns3 {
-  
+
 /**
  * \ingroup object
  *  Inspect a type to deduce its features.
@@ -45,7 +45,8 @@
    *  Not a const type.
    *  \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct UnConst
+  template <typename U>
+  struct UnConst
   {
     typedef U Result;                             /**< Non-const type.       */
   };
@@ -53,7 +54,8 @@
    *  Const type.
    *  \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct UnConst<const U>
+  template <typename U>
+  struct UnConst<const U>
   {
     typedef U Result;                             /**< Non-const type.       */
   };
@@ -61,55 +63,81 @@
    *  Not a reference type.
    *  \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct ReferenceTraits
+  template <typename U>
+  struct ReferenceTraits
   {
-    /** Value. */  enum { IsReference = 0         /**< Not a reference type. */ };
+    /** Value. */
+    enum
+    {
+      IsReference = 0                             /**< Not a reference type. */
+    };
     typedef U ReferencedType;                     /**< Base type.            */
   };
   /**
    *  Reference type.
    *  \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct ReferenceTraits<U&>
+  template <typename U>
+  struct ReferenceTraits<U&>
   {
-    /** Value. */  enum { IsReference = 1         /**< Reference type.       */ };
+    /** Value. */
+    enum
+    {
+      IsReference = 1                             /**< Reference type.       */
+    };
     typedef U ReferencedType;                     /**< Base type.            */
   };
   /**
    *  Not a pointer type.
    *  \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct PointerTraits
+  template <typename U>
+  struct PointerTraits
   {
-    /** Value. */  enum { IsPointer = 0,          /**< Not a pointer type.   */
-                          IsPtr = 0               /**< Not a Ptr type.       */};
+    /** Value. */
+    enum
+    {
+      IsPointer = 0,                              /**< Not a pointer type.   */
+      IsPtr = 0                                   /**< Not a Ptr type.       */
+    };
     typedef U PointeeType;                        /**< Base type.            */
   };
   /**
    *  Pointer type.
    *  \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct PointerTraits<U *>
+  template <typename U>
+  struct PointerTraits<U *>
   {
-    /** Value. */  enum { IsPointer = 1,          /**< Pointer type.         */
-                          IsPtr = 0               /**< Not a Ptr type.       */};
+    /** Value. */
+    enum
+    {
+      IsPointer = 1,                              /**< Pointer type.         */
+      IsPtr = 0                                   /**< Not a Ptr type.       */
+    };
     typedef U PointeeType;                        /**< Pointee type.         */
-  };  
+  };
   /**
    *  Ptr type.
    *  \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct PointerTraits<ns3::Ptr<U> >
+  template <typename U>
+  struct PointerTraits<ns3::Ptr<U> >
   {
-    /** Value. */  enum { IsPointer = 0,          /**< Not a pointer type.   */
-                          IsPtr = 1               /**< Ptr type.             */};
+    /** Value. */
+    enum
+    {
+      IsPointer = 0,                              /**< Not a pointer type.   */
+      IsPtr = 1                                   /**< Ptr type.             */
+    };
     typedef U PointeeType;                        /**< Pointee type.         */
   };
   /**
    * Base type, after removing \c &, \c * and \c const.
    * \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct Base
+  template <typename U>
+  struct Base
   {
     typedef U Type;                               /**< Base type.            */
   };
@@ -117,7 +145,8 @@
    * Base type, after removing \c &.
    * \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct Base <U &>
+  template <typename U>
+  struct Base <U &>
   {
     typedef typename Base<U>::Type Type;          /**< Base type.            */
   };
@@ -125,7 +154,8 @@
    * Base type, after removing \c *.
    * \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct Base <U *>
+  template <typename U>
+  struct Base <U *>
   {
     typedef typename Base<U>::Type  Type;         /**< Base type.            */
   };
@@ -133,7 +163,8 @@
    * Base type, after removing \c const.
    * \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct Base <const U >
+  template <typename U>
+  struct Base <const U >
   {
     typedef typename Base<U>::Type  Type;         /**< Base type.            */
   };
@@ -141,7 +172,8 @@
    * Base type of a Ptr.
    * \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct PtrBase
+  template <typename U>
+  struct PtrBase
   {
     typedef U Type;                               /**< Base type.            */
   };
@@ -149,7 +181,8 @@
    * Base type of a Ptr.
    * \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct PtrBase <ns3::Ptr<U> >
+  template <typename U>
+  struct PtrBase <ns3::Ptr<U> >
   {
     typedef U Type;                               /**< Base type.            */
   };
@@ -157,9 +190,14 @@
    *  Not a function pointer type.
    *  \tparam U \deduced The type being inspected.
    */
-  template <typename U> struct FunctionPtrTraits
+  template <typename U>
+  struct FunctionPtrTraits
   {
-    /** Value. */  enum { IsFunctionPointer = 0   /**< Not a function pointer. */ };
+    /** Value. */
+    enum
+    {
+      IsFunctionPointer = 0                       /**< Not a function pointer. */
+    };
     typedef NullType ReturnType;                  /**< Return type.            */
   };
   /**
@@ -169,8 +207,15 @@
   template <typename U>
   struct FunctionPtrTraits <U (*)(void)>
   {
-    /** Value. */  enum { IsFunctionPointer = 1   /**< Function pointer.     */ };
-    /** Value. */  enum { nArgs = 0               /**< Number of arguments.  */ };
+    /** Value. */
+    enum
+    {
+      IsFunctionPointer = 1                       /**< Function pointer.     */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 0                                   /**< Number of arguments.  */
+    };
     typedef U ReturnType;                         /**< Return type.          */
   };
   /**
@@ -182,8 +227,15 @@
             typename V1>
   struct FunctionPtrTraits <U (*)(V1)>
   {
-    /** Value. */  enum { IsFunctionPointer = 1   /**< Function pointer.     */ };
-    /** Value. */  enum { nArgs = 1               /**< Number of arguments.  */ };
+    /** Value. */
+    enum
+    {
+      IsFunctionPointer = 1                       /**< Function pointer.     */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 1                                   /**< Number of arguments.  */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef V1 Arg1Type;                          /**< First argument type.  */
   };
@@ -197,8 +249,15 @@
             typename V1, typename V2>
   struct FunctionPtrTraits <U (*)(V1,V2)>
   {
-    /** Value. */  enum { IsFunctionPointer = 1   /**< Function pointer.     */ };
-    /** Value. */  enum { nArgs = 2               /**< Number of arguments.  */ };
+    /** Value. */
+    enum
+    {
+      IsFunctionPointer = 1                       /**< Function pointer.     */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 2                                   /**< Number of arguments.  */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef V1 Arg1Type;                          /**< First argument type.  */
     typedef V2 Arg2Type;                          /**< Second argument type. */
@@ -214,8 +273,15 @@
             typename V1, typename V2, typename V3>
   struct FunctionPtrTraits <U (*)(V1,V2,V3)>
   {
-    /** Value. */  enum { IsFunctionPointer = 1   /**< Function pointer.     */ };
-    /** Value. */  enum { nArgs = 3               /**< Number of arguments.  */ };
+    /** Value. */
+    enum
+    {
+      IsFunctionPointer = 1                       /**< Function pointer.     */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 3                                   /**< Number of arguments.  */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef V1 Arg1Type;                          /**< First argument type.  */
     typedef V2 Arg2Type;                          /**< Second argument type. */
@@ -234,8 +300,15 @@
             typename V4>
   struct FunctionPtrTraits <U (*)(V1,V2,V3,V4)>
   {
-    /** Value. */  enum { IsFunctionPointer = 1   /**< Function pointer.     */ };
-    /** Value. */  enum { nArgs = 4               /**< Number of arguments.  */ };
+    /** Value. */
+    enum
+    {
+      IsFunctionPointer = 1                       /**< Function pointer.     */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 4                                   /**< Number of arguments.  */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef V1 Arg1Type;                          /**< First argument type.  */
     typedef V2 Arg2Type;                          /**< Second argument type. */
@@ -256,8 +329,15 @@
             typename V4, typename V5>
   struct FunctionPtrTraits <U (*)(V1,V2,V3,V4,V5)>
   {
-    /** Value. */  enum { IsFunctionPointer = 1   /**< Function pointer.     */ };
-    /** Value. */  enum { nArgs = 5               /**< Number of arguments.  */ };
+    /** Value. */
+    enum
+    {
+      IsFunctionPointer = 1                       /**< Function pointer.     */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 5                                   /**< Number of arguments.  */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef V1 Arg1Type;                          /**< First argument type.  */
     typedef V2 Arg2Type;                          /**< Second argument type. */
@@ -280,8 +360,15 @@
             typename V4, typename V5, typename V6>
   struct FunctionPtrTraits <U (*)(V1,V2,V3,V4,V5,V6)>
   {
-    /** Value. */  enum { IsFunctionPointer = 1   /**< Function pointer.     */ };
-    /** Value. */  enum { nArgs = 6               /**< Number of arguments.  */ };
+    /** Value. */
+    enum
+    {
+      IsFunctionPointer = 1                       /**< Function pointer.     */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 6                                   /**< Number of arguments.  */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef V1 Arg1Type;                          /**< First argument type.  */
     typedef V2 Arg2Type;                          /**< Second argument type. */
@@ -294,9 +381,14 @@
    *  Not a pointer to member type.
    *  \tparam U \deduced Return type.
    */
-  template <typename U> struct PtrToMemberTraits
+  template <typename U>
+  struct PtrToMemberTraits
   {
-    /** Value. */  enum { IsPointerToMember = 0   /**< Not a pointer to member.    */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 0                       /**< Not a pointer to member.    */
+    };
   };
   /**
    *  Pointer to member function.
@@ -304,10 +396,17 @@
    *  \tparam V \deduced Class type.
    */
   template <typename U,  typename V>
-  struct PtrToMemberTraits <U (V::*) (void)>
+  struct PtrToMemberTraits <U (V::*)(void)>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 0               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 0                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.                */
   };
   /**
@@ -316,10 +415,17 @@
    *  \tparam V \deduced Class type.
    */
   template <typename U,  typename V>
-  struct PtrToMemberTraits <U (V::*) (void) const>
+  struct PtrToMemberTraits <U (V::*)(void) const>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 0               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 0                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.                */
   };
   /**
@@ -330,10 +436,17 @@
    */
   template <typename U,  typename V,
             typename W1>
-  struct PtrToMemberTraits <U (V::*) (W1)>
+  struct PtrToMemberTraits <U (V::*)(W1)>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 1               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 1                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
   };
@@ -345,10 +458,17 @@
    */
   template <typename U,  typename V,
             typename W1>
-  struct PtrToMemberTraits <U (V::*) (W1) const>
+  struct PtrToMemberTraits <U (V::*)(W1) const>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 1               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 1                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
   };
@@ -361,10 +481,17 @@
    */
   template <typename U,  typename V,
             typename W1, typename W2>
-  struct PtrToMemberTraits <U (V::*) (W1,W2)>
+  struct PtrToMemberTraits <U (V::*)(W1,W2)>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 2               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 2                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -378,10 +505,17 @@
    */
   template <typename U,  typename V,
             typename W1, typename W2>
-  struct PtrToMemberTraits <U (V::*) (W1,W2) const>
+  struct PtrToMemberTraits <U (V::*)(W1,W2) const>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 2               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 2                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -396,10 +530,17 @@
    */
   template <typename U,  typename V,
             typename W1, typename W2, typename W3>
-  struct PtrToMemberTraits <U (V::*) (W1,W2,W3)>
+  struct PtrToMemberTraits <U (V::*)(W1,W2,W3)>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 3               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 3                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -415,10 +556,17 @@
    */
   template <typename U,  typename V,
             typename W1, typename W2, typename W3>
-  struct PtrToMemberTraits <U (V::*) (W1,W2,W3) const>
+  struct PtrToMemberTraits <U (V::*)(W1,W2,W3) const>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 3               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 3                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -436,10 +584,17 @@
   template <typename U,  typename V,
             typename W1, typename W2, typename W3,
             typename W4>
-  struct PtrToMemberTraits <U (V::*) (W1,W2,W3,W4)>
+  struct PtrToMemberTraits <U (V::*)(W1,W2,W3,W4)>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 4               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 4                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -458,10 +613,17 @@
   template <typename U,  typename V,
             typename W1, typename W2, typename W3,
             typename W4>
-  struct PtrToMemberTraits <U (V::*) (W1,W2,W3,W4) const>
+  struct PtrToMemberTraits <U (V::*)(W1,W2,W3,W4) const>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 4               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 4                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -481,10 +643,17 @@
   template <typename U,  typename V,
             typename W1, typename W2, typename W3,
             typename W4, typename W5>
-  struct PtrToMemberTraits <U (V::*) (W1,W2,W3,W4,W5)>
+  struct PtrToMemberTraits <U (V::*)(W1,W2,W3,W4,W5)>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 5               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 5                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -505,10 +674,17 @@
   template <typename U,  typename V,
             typename W1, typename W2, typename W3,
             typename W4, typename W5>
-  struct PtrToMemberTraits <U (V::*) (W1,W2,W3,W4,W5) const>
+  struct PtrToMemberTraits <U (V::*)(W1,W2,W3,W4,W5) const>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 5               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 5                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -530,10 +706,17 @@
   template <typename U,  typename V,
             typename W1, typename W2, typename W3,
             typename W4, typename W5, typename W6>
-  struct PtrToMemberTraits <U (V::*) (W1,W2,W3,W4,W5,W6)>
+  struct PtrToMemberTraits <U (V::*)(W1,W2,W3,W4,W5,W6)>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 6               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 6                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -556,10 +739,17 @@
   template <typename U,  typename V,
             typename W1, typename W2, typename W3,
             typename W4, typename W5, typename W6>
-  struct PtrToMemberTraits <U (V::*) (W1,W2,W3,W4,W5,W6) const>
+  struct PtrToMemberTraits <U (V::*)(W1,W2,W3,W4,W5,W6) const>
   {
-    /** Value. */  enum { IsPointerToMember = 1   /**< Pointer to member function. */ };
-    /** Value. */  enum { nArgs = 6               /**< Number of arguments.        */ };
+    /** Value. */
+    enum
+    {
+      IsPointerToMember = 1                       /**< Pointer to member function. */
+    };
+    /** Value. */ enum
+    {
+      nArgs = 6                                   /**< Number of arguments.        */
+    };
     typedef U ReturnType;                         /**< Return type.          */
     typedef W1 Arg1Type;                          /**< First argument type.  */
     typedef W2 Arg2Type;                          /**< Second argument type. */
@@ -581,7 +771,8 @@
   /** Ptr base type. */
   typedef typename PtrBase<T>::Type PtrBaseType;
   /** Predicates. */
-  enum {
+  enum
+  {
     /** Pointer to member predicate. */
     IsPointerToMember = PtrToMemberTraits<T>::IsPointerToMember,
     /** Pointer predicate. */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/uinteger.cc ns-3.31/src/core/model/uinteger.cc
--- ns-3.30.1/src/core/model/uinteger.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/uinteger.cc	2020-06-27 17:38:30.000000000 -0700
@@ -53,8 +53,10 @@
     Checker (uint64_t minValue, uint64_t maxValue, std::string name)
       : m_minValue (minValue),
         m_maxValue (maxValue),
-        m_name (name) {}
-    virtual bool Check (const AttributeValue &value) const {
+        m_name (name)
+    {}
+    virtual bool Check (const AttributeValue &value) const
+    {
       NS_LOG_FUNCTION (&value);
       const UintegerValue *v = dynamic_cast<const UintegerValue *> (&value);
       if (v == 0)
@@ -63,25 +65,30 @@
         }
       return v->Get () >= m_minValue && v->Get () <= m_maxValue;
     }
-    virtual std::string GetValueTypeName (void) const {
+    virtual std::string GetValueTypeName (void) const
+    {
       NS_LOG_FUNCTION_NOARGS ();
       return "ns3::UintegerValue";
     }
-    virtual bool HasUnderlyingTypeInformation (void) const {
+    virtual bool HasUnderlyingTypeInformation (void) const
+    {
       NS_LOG_FUNCTION_NOARGS ();
       return true;
     }
-    virtual std::string GetUnderlyingTypeInformation (void) const {
+    virtual std::string GetUnderlyingTypeInformation (void) const
+    {
       NS_LOG_FUNCTION_NOARGS ();
       std::ostringstream oss;
       oss << m_name << " " << m_minValue << ":" << m_maxValue;
       return oss.str ();
     }
-    virtual Ptr<AttributeValue> Create (void) const {
+    virtual Ptr<AttributeValue> Create (void) const
+    {
       NS_LOG_FUNCTION_NOARGS ();
       return ns3::Create<UintegerValue> ();
     }
-    virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const {
+    virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const
+    {
       NS_LOG_FUNCTION (&source << &destination);
       const UintegerValue *src = dynamic_cast<const UintegerValue *> (&source);
       UintegerValue *dst = dynamic_cast<UintegerValue *> (&destination);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/unix-fd-reader.cc ns-3.31/src/core/model/unix-fd-reader.cc
--- ns-3.30.1/src/core/model/unix-fd-reader.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/unix-fd-reader.cc	2020-06-27 17:38:30.000000000 -0700
@@ -19,6 +19,8 @@
  * Author: Tom Goff <thomas.goff@boeing.com>
  */
 
+#include <sys/select.h>
+
 #include <cerrno>
 #include <cstring>
 #include <unistd.h>  // close()
@@ -127,7 +129,9 @@
       char zero = 0;
       ssize_t len = write (m_evpipe[1], &zero, sizeof (zero));
       if (len != sizeof (zero))
-        NS_LOG_WARN ("incomplete write(): " << std::strerror (errno));
+        {
+          NS_LOG_WARN ("incomplete write(): " << std::strerror (errno));
+        }
     }
 
   // join the read thread
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/unix-fd-reader.h ns-3.31/src/core/model/unix-fd-reader.h
--- ns-3.30.1/src/core/model/unix-fd-reader.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/unix-fd-reader.h	2020-06-27 17:38:30.000000000 -0700
@@ -42,15 +42,15 @@
  * This class can be used to start a system thread that reads from a
  * given file descriptor and invokes a given callback when data is
  * received.  This class handles thread management automatically but
- * the \p DoRead() method must be implemented by a subclass.
+ * the \pname{DoRead()} method must be implemented by a subclass.
  */
 class FdReader : public SimpleRefCount<FdReader>
 {
 public:
   /** Constructor. */
-  FdReader();
+  FdReader ();
   /** Destructor. */
-  virtual ~FdReader();
+  virtual ~FdReader ();
 
   /**
    * Start a new read thread.
@@ -76,14 +76,16 @@
   struct Data
   {
     /** Default constructor, with null buffer and zero length. */
-    Data () : m_buf (0), m_len (0) {}
+    Data () : m_buf (0), m_len (0)
+    {}
     /**
      * Construct from a buffer of a given length.
      *
      * \param [in] buf The buffer.
      * \param [in] len The size of the buffer, in bytes.
      */
-    Data (uint8_t *buf, ssize_t len) : m_buf (buf), m_len (len) {}
+    Data (uint8_t *buf, ssize_t len) : m_buf (buf), m_len (len)
+    {}
     /** The read data buffer. */
     uint8_t *m_buf;
     /** The size of the read data buffer, in bytes. */
@@ -93,12 +95,12 @@
   /**
    * \brief The read implementation.
    *
-   * The value of \p m_len returned controls further processing.  The
-   * callback function is only invoked when \p m_len is positive; any
-   * data read is not processed when \p m_len is negative; reading
-   * stops when \p m_len is zero.
+   * The value of \pname{m_len} returned controls further processing.  The
+   * callback function is only invoked when \pname{m_len} is positive; any
+   * data read is not processed when \pname{m_len} is negative; reading
+   * stops when \pname{m_len} is zero.
    *
-   * The management of memory associated with \p m_buf must be
+   * The management of memory associated with \pname{m_buf} must be
    * compatible with the read callback.
    *
    * \return A structure representing what was read.
@@ -119,7 +121,7 @@
 
   /** The main thread callback function to invoke when we have data. */
   Callback<void, uint8_t *, ssize_t> m_readCallback;
-  
+
   /** The thread doing the read, created and launched by Start(). */
   Ptr<SystemThread> m_readThread;
 
@@ -127,7 +129,7 @@
   int m_evpipe[2];
   /** Signal the read thread to stop. */
   bool m_stop;
-  
+
   /**
    * The event scheduled for destroy time which will invoke DestroyEvent
    * and halt the thread.
